// **********************************************************************
//
// Copyright (c) 2003-2017 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.7.0
//
// <auto-generated>
//
// Generated from file `ConnectionInfo.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

#ifndef __IceBT_ConnectionInfo_h__
#define __IceBT_ConnectionInfo_h__

#include <IceUtil/PushDisableWarnings.h>
#include <Ice/ProxyF.h>
#include <Ice/ObjectF.h>
#include <Ice/ValueF.h>
#include <Ice/Exception.h>
#include <Ice/LocalObject.h>
#include <Ice/StreamHelpers.h>
#include <Ice/Comparable.h>
#include <Ice/OutgoingAsync.h>
#include <IceUtil/ScopedArray.h>
#include <Ice/Optional.h>
#include <Ice/Connection.h>
#include <IceUtil/UndefSysMacros.h>

#ifndef ICE_IGNORE_VERSION
#   if ICE_INT_VERSION / 100 != 307
#       error Ice version mismatch!
#   endif
#   if ICE_INT_VERSION % 100 > 50
#       error Beta header file detected
#   endif
#   if ICE_INT_VERSION % 100 < 0
#       error Ice patch level mismatch!
#   endif
#endif

#ifndef ICEBT_API
#   if defined(ICE_STATIC_LIBS)
#       define ICEBT_API /**/
#   elif defined(ICEBT_API_EXPORTS)
#       define ICEBT_API ICE_DECLSPEC_EXPORT
#   else
#       define ICEBT_API ICE_DECLSPEC_IMPORT
#   endif
#endif

#ifdef ICE_CPP11_MAPPING // C++11 mapping

namespace IceBT
{

class ConnectionInfo;

}

namespace IceBT
{

class ICE_CLASS(ICEBT_API) ConnectionInfo : public ::Ice::ConnectionInfo
{
public:

    ICE_MEMBER(ICEBT_API) virtual ~ConnectionInfo();

    ConnectionInfo() :
        localAddress(""),
        localChannel(-1),
        remoteAddress(""),
        remoteChannel(-1),
        uuid(""),
        rcvSize(0),
        sndSize(0)
    {
    }

    ConnectionInfo(const ConnectionInfo&) = default;
    ConnectionInfo(ConnectionInfo&&) = default;
    ConnectionInfo& operator=(const ConnectionInfo&) = default;
    ConnectionInfo& operator=(ConnectionInfo&&) = default;

    ConnectionInfo(const ::std::shared_ptr<::Ice::ConnectionInfo>& iceP_underlying, bool iceP_incoming, const ::std::string& iceP_adapterName, const ::std::string& iceP_connectionId, const ::std::string& iceP_localAddress, int iceP_localChannel, const ::std::string& iceP_remoteAddress, int iceP_remoteChannel, const ::std::string& iceP_uuid, int iceP_rcvSize, int iceP_sndSize) :
        ::Ice::ConnectionInfo(::std::move(iceP_underlying), iceP_incoming, ::std::move(iceP_adapterName), ::std::move(iceP_connectionId)),
        localAddress(::std::move(iceP_localAddress)),
        localChannel(iceP_localChannel),
        remoteAddress(::std::move(iceP_remoteAddress)),
        remoteChannel(iceP_remoteChannel),
        uuid(::std::move(iceP_uuid)),
        rcvSize(iceP_rcvSize),
        sndSize(iceP_sndSize)
    {
    }

    ::std::string localAddress;
    int localChannel = -1;
    ::std::string remoteAddress;
    int remoteChannel = -1;
    ::std::string uuid;
    int rcvSize = 0;
    int sndSize = 0;
};

}

namespace Ice
{

}

namespace IceBT
{

using ConnectionInfoPtr = ::std::shared_ptr<ConnectionInfo>;

}

#else // C++98 mapping

namespace IceBT
{

class ConnectionInfo;
ICEBT_API ::Ice::LocalObject* upCast(::IceBT::ConnectionInfo*);
typedef ::IceInternal::Handle< ::IceBT::ConnectionInfo> ConnectionInfoPtr;

}

namespace IceBT
{

class ICEBT_API ConnectionInfo : public ::Ice::ConnectionInfo
{
public:

    typedef ConnectionInfoPtr PointerType;

    virtual ~ConnectionInfo();

    ConnectionInfo() :
        localAddress(""),
        localChannel(-1),
        remoteAddress(""),
        remoteChannel(-1),
        uuid(""),
        rcvSize(0),
        sndSize(0)
    {
    }

    ConnectionInfo(const ::Ice::ConnectionInfoPtr& iceP_underlying, bool iceP_incoming, const ::std::string& iceP_adapterName, const ::std::string& iceP_connectionId, const ::std::string& iceP_localAddress, ::Ice::Int iceP_localChannel, const ::std::string& iceP_remoteAddress, ::Ice::Int iceP_remoteChannel, const ::std::string& iceP_uuid, ::Ice::Int iceP_rcvSize, ::Ice::Int iceP_sndSize) :
        ::Ice::ConnectionInfo(iceP_underlying, iceP_incoming, iceP_adapterName, iceP_connectionId),
        localAddress(iceP_localAddress),
        localChannel(iceP_localChannel),
        remoteAddress(iceP_remoteAddress),
        remoteChannel(iceP_remoteChannel),
        uuid(iceP_uuid),
        rcvSize(iceP_rcvSize),
        sndSize(iceP_sndSize)
    {
    }

    ::std::string localAddress;
    ::Ice::Int localChannel;
    ::std::string remoteAddress;
    ::Ice::Int remoteChannel;
    ::std::string uuid;
    ::Ice::Int rcvSize;
    ::Ice::Int sndSize;
};

inline bool operator==(const ConnectionInfo& lhs, const ConnectionInfo& rhs)
{
    return static_cast<const ::Ice::LocalObject&>(lhs) == static_cast<const ::Ice::LocalObject&>(rhs);
}

inline bool operator<(const ConnectionInfo& lhs, const ConnectionInfo& rhs)
{
    return static_cast<const ::Ice::LocalObject&>(lhs) < static_cast<const ::Ice::LocalObject&>(rhs);
}

}

namespace Ice
{

}

#endif

#include <IceUtil/PopDisableWarnings.h>
#endif
